;*****************************************************************************************
; Program :	INTRC mode
; Description :	Demonstrate operation in INTRC oscillator mode of PIC16F628
; Filename :	hlab0701.asm
;*****************************************************************************************
           LIST	P=16F628,W=-302
PORTB	EQU	0x06		; Bank 0
TRISB	EQU	0x86		; Bank 1
PCON	EQU	0x8E		; Bank 1
OSCF	EQU	3
COUNT	EQU	0x70		; Common RAM : every bank 
;*************************************************************
	__CONFIG	0x3F71
	ORG	0x000

	BANKSEL	PCON		; Bank 1
	BSF	PCON,OSCF       ; Fast/slow speed
	
	CLRF	TRISB		; Port B are output 
	BANKSEL	PORTB		; Bank 0		

	CLRF	PORTB		; Clear port B
	SETC
ROTATE	RRF	PORTB,1
	CALL	DELAY
	GOTO	ROTATE		
DELAY	CLRF	COUNT
	MOVLW	.75
	MOVWF	COUNT+1
	DECFSZ	COUNT,1
	GOTO	$-1
	DECFSZ	COUNT+1,1
	GOTO	$-3
	RETURN

	END
