;*****************************************************************************************
; Program :	EC mode
; Description :	Demonstrate operation of PIC16F628 with external clock
; Filename :	hlab0901.asm
;*****************************************************************************************
	LIST	P=16F628 ,W=-302
PORTB	EQU	0x06		; Bank 0
PORTA	EQU	0x05
TRISB	EQU	0x86		; Bank 1
TRISA	EQU	0x85
COUNT	EQU	0x70		; Common RAM : every bank
;*************************************************************
	__CONFIG	0x3F63
	ORG	0x000

	BANKSEL	TRISB		; Bank 1
	CLRF	TRISB		; Port B are output 
	BCF	TRISA,6		; RA6 = output 
	BANKSEL	PORTB		; Bank 0		
	CLRF	PORTB		; Clear port B
	BCF	PORTA,6
	SETC
ROTATE	RRF	PORTB,1
	COMF	PORTA
       	CALL	DELAY
       	GOTO	ROTATE		
DELAY	MOVLW	.10
	MOVWF	COUNT
	DECFSZ	COUNT,1
	GOTO	$-1
	RETURN

	END
