;*************************************************************************************
; Program :	3-digits LED multiplexed display
; Description :	Demonstrate multiplexing 3-digits LED display to show "Hello" message
; Filename :	hlab1101.asm
;*************************************************************************************

	LIST	P=16F628,W=-302

PORTA	EQU	0x05
PORTB	EQU	0x06
TRISA	EQU	0x85
TRISB	EQU	0x86
CMCON	EQU	0x1F

     	CBLOCK	0x20
     	TEMP1,TEMP2,SPEED,CHAR1,CHAR2,CHAR3,CHAR4,CHAR5,CHAR6,CHAR7,CHAR8
     	ENDC
    	__CONFIG	0x3F61

	ORG	0x000

INIT_PORTB
	MOVLW	.7
	MOVWF	CMCON		; RA2-RA0 = digital I/O 
	BANKSEL	TRISA		; Bank select
	MOVLW	B'11111000'	; RA2-RA0 as output 
	MOVWF	TRISA	
	CLRF	TRISB		; Port B as output
	BANKSEL	PORTA		; Bank select
	CLRF	PORTA		; Turn-off every digit 
	CLRF	PORTB		; Clear port B		
GET_CHAR
	MOVLW	0x00		; Blank
	MOVWF	CHAR1
	
	MOVLW	0x00		; Blank
	MOVWF	CHAR2

	MOVLW	0x00		; Blank
	MOVWF	CHAR3
	
	MOVLW	0x74		; H
	MOVWF	CHAR4
	
	MOVLW	0x79		; E
	MOVWF	CHAR5
	
	MOVLW	0x38		; L
	MOVWF	CHAR6
	
	MOVLW	0x38		; L
	MOVWF	CHAR7

	MOVLW	0x5C		; O
	MOVWF	CHAR8

; SCAN LEFT => RIGHT	
SCAN 	MOVLW	.35		; !!! Chang speed here !!!	
	MOVWF	SPEED
DIGIT3	MOVFW	CHAR1
	MOVWF	PORTB	
	MOVLW	B'11111011'	; Turn-off digit 3
	MOVWF	PORTA		; Common cathode
	CALL	DELAY

DIGIT2	MOVFW	CHAR2
	MOVWF	PORTB
	MOVLW	B'11111101'	; Turn-on digit 2
	MOVWF	PORTA
	CALL	DELAY

DIGIT1	MOVFW	CHAR3
	MOVWF	PORTB
	MOVLW	B'11111110'	; Turn-on digit 1
	MOVWF	PORTA
	CALL	DELAY
	CLRZ			; Clear flag Z
	DECF	SPEED,1	 
	BNZ	DIGIT3		; Do it again
	CALL	EXCHANGE	; Exchange character 
	GOTO	SCAN

;!!!!!!!!!!!!!!!  SUBROUTINES  !!!!!!!!!!!!!!!!!
DELAY	MOVLW	.5		; !!! Change scanning time here !!!	
	MOVWF	TEMP2	

	CLRF	TEMP1
	DECFSZ	TEMP1,1
	GOTO	$-1
	DECFSZ	TEMP2,1
	GOTO	$-3
	RETURN			
EXCHANGE MOVFW	CHAR1
	MOVWF	TEMP1		; Store to buffer 
	
	MOVFW	CHAR2		; Exchange Char2 and Char1
	MOVWF	CHAR1
	
	MOVFW	CHAR3		; And so on ...
	MOVWF	CHAR2
	
	MOVFW	CHAR4
	MOVWF	CHAR3
	
	MOVFW	CHAR5
	MOVWF	CHAR4
	
	MOVFW	CHAR6
	MOVWF	CHAR5
	
	MOVFW	CHAR7
	MOVWF	CHAR6

	MOVFW	CHAR8
	MOVWF	CHAR7
	
	MOVFW	TEMP1		; Restore to Char8 
	MOVWF	CHAR8	

	RETURN
;!!!!!!!!!!!!!!!!! END OF SUBROUTINES !!!!!!!!!!!!!!!!!

	END

