;**********************************************
;Program :	Reading data EEPROM 
;Description :	Demonstrate reading data EEPROM 
;Filename :	hlab1202.asm
;**********************************************

	LIST	P=16F628 ,W=-302
PORTB   EQU   	0x06
TRISB   EQU  	0x86
EEDATA 	EQU  	0x9A
EEADR 	EQU   	0x9B
EECON1	EQU   	0x9C
EECON2	EQU	0x9D
WREN	EQU	2
WR	EQU	1
RD   	EQU 	0

;**************************************************************
      	 __CONFIG        0x3F61

START  	ORG   	0x000
PORTB_INIT
	BANKSEL	TRISB		; Bank 1
   	MOVLW  	B'00000000'	; Port B as output
    	MOVWF  	TRISB           
       	BANKSEL	PORTB           ; Bank 0
       	CLRF  	PORTB           ; Clear port B
                	
;*****************  FILL ADDRESS & DATA  **********************
	BANKSEL	EEADR
	
     	MOVLW	0x50		; Fill address 
      	MOVWF	EEADR

     	MOVLW	0x88   		; Fill data
    	MOVWF	EEDATA
                
;**************************************************************               

DISPLAY	CALL	WRITE_EEPROM
	CALL	READ_EEPROM
	BANKSEL	PORTB
	MOVWF	PORTB		; Display
	GOTO	$

;**********************  SUBROUTINE  ********************************
WRITE_EEPROM 
	BANKSEL	EECON1		; Bank 1
	BSF	EECON1,WREN	; Enable write	

	MOVLW	0x55
	MOVWF	EECON2
	MOVLW	0xAA
	MOVWF	EECON2

	BSF	EECON1,WR	; Start write	
	BTFSC	EECON1,WR	
	GOTO	$-1		; Wait for writing 
	BCF	EECON1,WREN	; Disable write
	RETURN
;************** END OF WRITE **********************************	

READ_EEPROM
      	BANKSEL EECON1          ; Bank 1
        BSF	EECON1,RD       ; Start read
	MOVFW	EEDATA          ; Move data to w register
	RETURN
;************* END OF READ  ***********************************

   	END
