;***********************************************************
; Program :		5kHz pulse generator
; Description :	Generate 5kHz pulse signal from Timer0
; filename :	hlab1302.asm
;***********************************************************
	LIST	P=16F628,W=-302
PORTB	EQU	0x06
TMR0	EQU	0x01
INTCON	EQU	0x0B
TRISB	EQU	0x86
OPTION_REG	EQU	0x81 		; Use this name for OPTION register
T0IF	EQU	2

	__CONFIG	0x3F61
	ORG	0x0000
INIT_PORTB	BCF	PORTB,0	; Clear RB0
	BANKSEL	TRISB
	BCF	TRISB,0
TMR0_SETUP	MOVLW	B'11001000' 	; Timer module mode, no prescaler  
	MOVWF	OPTION_REG	; Because it assigned to watchdog timer (WDT)
LOOP	BCF	INTCON,T0IF	; Clear flag
	BANKSEL 	TMR0 		; Return to bank 0
	MOVLW	.156		; Value for overflow
	MOVWF	TMR0		; Start TMR0
	
	BTFSS	INTCON,T0IF 
	GOTO	$-1
	COMF	PORTB,1	
	GOTO	LOOP	

	END
