;***********************************************************
; Program	:	500Hz pulse generator 
; Description :	Generate 500Hz pulse with Timer0
; Filename :		hlab1303.asm
;***********************************************************
	LIST	P=16F628,W=-302
PORTB	EQU	0x06
TMR0	EQU	0x01
INTCON	EQU	0x0B
TRISB	EQU	0x86
OPTION_REG	EQU	0x81 		; Use this name for OPTION register
T0IF	EQU	2

	__CONFIG	0x3F61
	ORG	0x0000
INIT_PORTB	BCF	PORTB,0		; Clear RB0
	BANKSEL	TRISB
	BCF	TRISB,0
TMR0_SETUP	MOVLW	B'11000001' 	; Timer mode,prescaler 1:4
	MOVWF	OPTION_REG
LOOP	BCF	INTCON,T0IF		; Clear flag
	BANKSEL 	TMR0 		; Return to bank 0
	MOVLW	.6			; Value for overflow
	MOVWF	TMR0			; Start TMR0
		
	BTFSS	INTCON,T0IF 
	GOTO	$-1
	COMF	PORTB,1	
	GOTO	LOOP	

	END
