;*********************************************
; Program :	Timer0 counter
; Description :	Using Timer0 in counter mode
; Filename :	hlab1304.asm
;*********************************************
	LIST	P=16F628,W=-302
TMR0	EQU	0x01
PORTB	EQU	0x06
INTCON	EQU	0x0B
TRISA	EQU	0x85
TRISB	EQU	0x86
OPTION_REG	EQU	0x81
T0IF	EQU	2

	__CONFIG	0x3F61
	ORG	0x0000

	CLRF	PORTB
	BANKSEL	TRISA		; Bank 1
	BSF	TRISA,4		; RA4 as input
	CLRF	PORTB		; Port B as output
	MOVLW	B'11110001'	; Counter mode, T0PRE = 1:4
	MOVWF	OPTION_REG
	BANKSEL	INTCON		; Bank 0
	SETC			; Special instruction to set C = 1
LOOP	RRF	PORTB,1
	BTFSS	INTCON,T0IF
	GOTO	$-1
	BCF	INTCON,T0IF	; Clear overflow flag
	MOVLW	.231
	MOVWF	TMR0	
	GOTO	LOOP
	END
