;***************************************************************************
; Program :		Delay with Timer1 (2)
; Description :	Demonstrate delay operation of Timer1 in counter mode
; Filename :	hlab1402.asm
;***************************************************************************
	LIST	P=16F628,W=-302
PORTB	EQU	0x06
TRISB	EQU	0x86
PIR1	EQU	0x0C
TMR1L	EQU	0x0E
TMR1H	EQU	0x0F
T1CON	EQU	0x10

TMR1ON	EQU	0
TMR1IF	EQU	0

	__CONFIG	0x3F61
	ORG	0x000

INIT_PORTB	CLRF	PORTB	; Clear port B
	BANKSEL	TRISB
	MOVLW	B'11111100'	; RB1,RB0 as output
	MOVWF	TRISB	; RB6 as input
	BANKSEL	PORTB
SET_TMR1	MOVLW	B'00100010'	; Prescaler 1:4 in counter mode
	MOVWF	T1CON	; TMR1 off
LOOP	CALL	TMR1_VALUE
	MOVLW	B'00000001'
	MOVWF	PORTB
	BTFSS	PIR1,TMR1IF	 ; Wait overflow
	GOTO	$-1
	BCF	T1CON,TMR1ON 	; TMR1 off
	BCF	PIR1,TMR1IF  	; Clear overflow flag

	CALL	TMR1_VALUE  
	MOVLW	B'00000010'
	MOVWF	PORTB
	BTFSS	PIR1,TMR1IF
	GOTO	$-1
	BCF	T1CON,TMR1ON 	; TMR1 off
	BCF	PIR1,TMR1IF  	; Clear overflow flag
	GOTO	LOOP
TMR1_VALUE	MOVLW	0x83
	MOVWF	TMR1L	 		; TMR1L value
	MOVLW	0xFF
	MOVWF	TMR1H	 		; TMR1H value
	BSF	T1CON,TMR1ON 	; TMR1 on
	RETURN
	
	END

