;********************************************************************
; Program :	Frequency counter with binary display
; Description :	Using Timer1 for counting frequency and 
;		diplay in binary with LED at Port B
; Filename :	hlab1403.asm
;********************************************************************
	LIST	P=16F628,W=-302
TMR1L	EQU	0E			; Bank 0
TMR1H	EQU	0F
T1CON	EQU	10
PORTB	EQU	06
PORTA	EQU	05
CMCON	EQU	1F
COUNTER	EQU	20			; Bank 0 only
TRISB	EQU	86			; Bank 1
TRISA	EQU	85

TMR1ON	EQU	0 			; Bit

	__CONFIG	3F70
	ORG	0000
	
INIT_PORT				; 11-bit output (4RA + 7RB) = 2048 count		
	MOVLW	07			; RA3-RA0 = digital I/O
	MOVWF	CMCON
	BANKSEL	TRISB
	MOVLW	B'01000000'
	MOVWF	TRISB			; RB6 as input
	MOVLW	B'01111000'	
	MOVWF	TRISA
	BANKSEL	PORTB
	CLRF	PORTB
	CLRF	PORTA
INIT_TMR1
	MOVLW	B'00000010' 	; Prescaler = 1:1
	MOVWF	T1CON			; Counter mode		
AGAIN	CLRF	TMR1H
	CLRF	TMR1L
	BSF	T1CON,TMR1ON	; Timer1 on
	CALL	TIMER_1SEC	; 2 Tcy
	BCF	T1CON,TMR1ON	; Timer1 off 1 Tcy
	MOVFW	TMR1H
	MOVWF	PORTA
	MOVFW	TMR1L
	MOVWF	PORTB
	BTFSC	TMR1L,6
	GOTO	$+3
	BCF	PORTA,7
	GOTO	AGAIN
	BSF	PORTA,7
	GOTO	AGAIN
	
TIMER_1SEC
	MOVLW	.11
	MOVWF	COUNTER		; RAM address 20
LOOP	CLRF	COUNTER+1   	; RAM address 21
	MOVLW	.118
	MOVWF	COUNTER+2	; RAM address 23
	DECFSZ	COUNTER+1,1
	GOTO	$-1
	DECFSZ	COUNTER+2,1
	GOTO	$-3
	DECF	COUNTER,1
	TSTF	COUNTER		; Test flag Z
	BNZ	LOOP			 
	MOVLW	.150
	MOVWF	COUNTER+1
	DECFSZ	COUNTER+1,1
	GOTO	$-1			; After this instruction =999989
	GOTO	$+1			; 2 Tcy
	GOTO	$+1			; 2 Tcy
	GOTO	$+1			; 2 Tcy
	RETURN

	END

