;*****************************************************************************************
; Program :	Timer1 with external oscillator
; Description :	Using Timer1 with crystal and external clock source
; Filename :	hlab1404.asm
;*****************************************************************************************
	LIST	P=16F628,W=-302

PORTB	EQU	0x06
TRISB	EQU	0x86
PIR1	EQU	0x0C
TMR1L	EQU	0x0E
TMR1H	EQU	0x0F
T1CON	EQU	0x10
 
TMR1ON	EQU	0
TMR1IF	EQU	0

	__CONFIG	0x3F70
	ORG	0x000
	
INIT_PORTB
	CLRF	PORTB			; Clear PORTB
	BANKSEL	TRISB
	MOVLW	B'00111100'	; RB1,RB0 as output
	MOVWF	TRISB			; RB7,RB6 as output
	BANKSEL	PORTB
TMR1SETUP
	MOVLW	B'00001010'	; Prescaler 1:1 , counter mode,
	MOVWF	T1CON			; Forced RB7,RB6 to input
LOOP
	CALL	TMR1_VALUE
	MOVLW	B'00000001'
	MOVWF	PORTB
	BTFSS	PIR1,TMR1IF	 ; Wait overflow
	GOTO	$-1
	BCF	T1CON,TMR1ON 	; TMR1 off
	BCF	PIR1,TMR1IF  	; Clear overflow flag
	CALL	TMR1_VALUE  
	MOVLW	B'00000010'
	MOVWF	PORTB
	BTFSS	PIR1,TMR1IF
	GOTO	$-1
	BCF	T1CON,TMR1ON 	; TMR1 off
	BCF	PIR1,TMR1IF  	; Clear overflow flag
	GOTO	LOOP	
TMR1_VALUE
	MOVLW	0xC0
	MOVWF	TMR1H	 		; TMR1H value

	MOVLW	0x00
	MOVWF	TMR1L	 		; TMR1L value
	BSF	T1CON,TMR1ON 	; TMR1 on
	RETURN
	
	END

