;*****************************************************************************************
; Program :	Timer1 in sleep mode
; Description :	Using Timer1 when microcontroller operated in sleep mode
; Filename :	hlab1405.asm
;*****************************************************************************************
	LIST	P=16F628,W=-302

PORTB	EQU	0x06

INTCON	EQU	0x0B			; Bank 0
PIR1	EQU	0x0C
TMR1L	EQU	0x0E
TMR1H	EQU	0x0F
T1CON	EQU	0x10
TRISB	EQU	0x86			; Bank 1
PIE1	EQU	0x8C
 
TMR1ON	EQU	0
TMR1IF	EQU	0
TMR1IE	EQU	0
PEIE	EQU	6

RESET	ORG	0x0000	

	CLRF	PORTB			; Clear port B
	BANKSEL	TRISB
	BCF	TRISB,0		; RB0 as output 
	BSF	PIE1,TMR1IE	; Enable TMR1 Flag

	BANKSEL	INTCON
SETUP
	BSF	INTCON,PEIE	; Enable wake-up from sleep
	MOVLW	B'00111110'	; Prescaler 1:8,Counter mode
	MOVWF	T1CON			; Run in asynchronous mode only
LOOP
	MOVLW	0xF0	 		; 1 second 
	MOVWF	TMR1H	 		; TMR1H value
	MOVLW	0x00
	MOVWF	TMR1L	 		; TMR1L value
	BSF	T1CON,TMR1ON 	; Timer on
	SLEEP		 		; Enter powerdown mode
	BCF	T1CON,TMR1ON 	; Timer off
	BCF	PIR1,TMR1IF
	COMF	PORTB,1
	GOTO	LOOP
	
	__CONFIG	0x3F70	 	; PIC16F628 s config data

	END
