;*******************************************************************************
; Program :	Timer2 operation
; Description :	Generate 100Hz pulse signal
; Filename :	hlab1501.asm
;*****************************************************************************************
	LIST	P=16F628,W=-302
	
;************ TIMER2 FORMULAS ************
; TIME = PRE*(PR2+1)*POST*4/FOSC    SECOND
; PR2  = (TIME*FOSC)/(4*PRE*POST)-1
;*****************************************

;**************** BANK 0 *****************
PORTB	EQU	0x06	
PIR1	EQU	0x0C	
TMR2	EQU	0x11	
T2CON	EQU	0x12	
;**************** BANK 1 *****************
TRISB	EQU	0x86	
PR2	EQU	0x92	
;****************  BIT  ******************
TMR2IF	EQU	1
TMR2ON	EQU	2
;*****************************************
	__CONFIG	0x3F21
	ORG	0x0000
	
	BANKSEL	TRISB	 		; Select TRISB
	BCF	TRISB,0      		; RB0 as output
	MOVLW	.249  	 		; Delay 5 mS
	MOVWF	PR2

	BANKSEL	PORTB	 		; Select PORTB
	BCF	PORTB,0
	MOVLW	B'00100001'  	; PRE = 4, POST = 5,
	MOVWF	T2CON	 		; TMR2= off
	CLRF	TMR2	 		; Clear TIMER2
	BSF	T2CON,TMR2ON 	; TMR2= on
WAIT	BTFSS	PIR1,TMR2IF
	GOTO	WAIT	 		; Wait for overflow
	BCF	PIR1,TMR2IF	; Clear flag	
CLEAR_BIT	BTFSS	PORTB,0
	GOTO	SET_BIT
	BCF	PORTB,0		; RB0 = 0
	GOTO	WAIT
SET_BIT	BSF	PORTB,0 	 	; RB0 = 1	
	GOTO	WAIT
			
	END
