;*****************************************************************************************
; Program :	Watchdog timer 
; Description :	Demonstrate watchdog timer operation
; Filename :	hlab1601.asm
;*****************************************************************************************
	LIST	P=16F628,W=-302
OPTION_REG	EQU	0x81
TRISA	EQU	0x85
PORTA	EQU	0x05
TRISB	EQU	0x86
PORTB	EQU	0x06
STATUS	EQU	0x03
TD_BIT	EQU	4

	ORG	0x000
	BANKSEL	OPTION_REG	
	MOVLW	B'11111100' 	; Postscaler ~ 2.304 seconds
	MOVWF	OPTION_REG  
	CLRF	TRISB			; PORTB as output
	BCF	TRISA,4		; RA4 as output (open Drain)

	BANKSEL	PORTB
	CLRF	PORTB
	MOVFW	STATUS	
	MOVWF	PORTA
	SETC	
LEFT	RLF	PORTB,1
	CALL	DELAY
	GOTO	LEFT
DELAY	CLRF	0x70
	CLRF	0x71
	MOVLW	.2
	MOVWF	0x72
	DECFSZ	0x70,1 
	GOTO	$-1
	DECFSZ	0x71,1
	GOTO	$-3
	DECFSZ	0x72,1
	GOTO	$-5			; Clear watchdog timer
	RETURN

	__CONFIG	0x3F61

	END

