;****************************************************************
; Program : 	Timer 1 interrupt
; Description : 	Demonstrate interrupt from Timer1 overflow
; Filename : 	hlab1701.asm
;****************************************************************
	LIST	P=16F628,W=-302
STATUS	EQU	0x03	; Bank 0
PORTB	EQU	0x06	
INTCON	EQU	0x0B
PIR1	EQU	0x0C
TMR1L	EQU	0x0E	
TMR1H	EQU	0x0F
T1CON	EQU	0x10
TRISB	EQU	0x86	; Bank 1
PIE1	EQU	0x8C		
RP0	EQU	5
TMR1IE	EQU	0
TMR1IF	EQU	0
PEIE	EQU	6
GIE	EQU	7
TMR1ON	EQU	0
	__CONFIG	0x3F61	

	ORG	0x0000	; Line 1	
	GOTO	MAIN_PROG	; Line 2
	ORG	0x0004	; Line 3
	GOTO	ISR	; Line 4
MAIN_PROG	BSF	STATUS,RP0	; Line 5, Bank 1	
	CLRF	TRISB	; Line 6, PORTB as output
	BSF	PIE1,TMR1IE 	; Line 7, Timer1 interrupt enable
	BCF	STATUS,RP0	; Line 8, Bank 0
	CLRF	PORTB	; Line 9, Clear port B
	BSF	INTCON,PEIE 	; Line 10, Peripheral interrupt enable
	BSF	INTCON,GIE  	; Line 11, Global interrupt enable
LOOP1	MOVLW	0xFF	; Line 12  
	MOVWF	TMR1H	; Line 13, Set Timer1 value
	MOVLW	0xFA	; Line 14
	MOVWF	TMR1L	; Line 15
	BSF	T1CON,TMR1ON	; Line 16, Start Timer1
	NOP		; Line 17 
	NOP		; Line 18
	NOP		; Line 19
	NOP		; Line 20
	NOP		; Line 21
	MOVLW	0xFF	; Line 22
LOOP2	GOTO	LOOP2	; Line 23
	CALL	AAA	; Line 24
	NOP		; Line  25
LOOP3	GOTO	LOOP3	; Line 26
AAA	NOP		; Line 27
	RETURN		; Line 28
ISR	BCF	PIR1,TMR1IF	; Line 29, Clear flag
	BCF	T1CON,TMR1ON	; Line 30 
	MOVWF	PORTB	; Line 31
	RETFIE 		; Line 32

	END
