;*****************************************************************************************
; Program :	Timer2 interrupt operation
; Description :	Generate 100Hz pulse signal by Timer 2s interrupt
; Filename :	hlab1803.asm
;*****************************************************************************************
	LIST	P=16F628,W=-302
;************* BYTE *****************
INTCON	EQU	0x0B	; Every Bank
PORTB	EQU	0x06	; Bank 0
PIR1	EQU	0x0C	; 
TMR2	EQU	0x11	;
T2CON	EQU	0x12	;
TRISB	EQU	0x86	; Bank 1
PIE1	EQU	0x8C	;
PR2	EQU	0x92	;
GIE	EQU	7
PEIE	EQU	6
TMR2IF	EQU	1
TMR2IE	EQU	1
TMR2ON	EQU	2
;************************************
	__CONFIG	0x3F21

RESET_ADDR	ORG	0x000
	GOTO	START
	
INT_ADDR	ORG	0x004
	GOTO	ISR
START	; THIS ADDR. = 0x005		
	BANKSEL	TRISB		; Bank 1
	BCF	TRISB,0	; RB0 as output
	MOVLW	.49	; 0.5 ms
	MOVWF	PR2
	BSF	PIE1,TMR2IE	; Enable TMR2 interrupt

	BANKSEL	PORTB	
	BCF	PORTB,0	; Clear RB0
	MOVLW	B'01001000'	; Load data to prescaler
	MOVWF	T2CON	;  , TMR2 off
	CLRF	TMR2	; Clear TIMER2
	BSF	INTCON,PEIE	; Enable peripheral 
	BSF	INTCON,GIE	; Enable global interrupt
	BSF	T2CON,TMR2ON ; TMR2 on
WAIT_INT	GOTO	WAIT_INT	; Wait for interrupt	

;****************** INTERRUPT SERVICE ROUTINE **************************
ISR
	BCF	PIR1,TMR2IF	; Clear TMR2 flag after inrrupt occured
	BTFSS	PORTB,0	; Test RB0 = 1 ?
	GOTO	SET_RB0	; No,then jump
CLEAR_RB0	BCF	PORTB,0	; Yes
 	RETFIE		
SET_RB0	BSF	PORTB,0	
	RETFIE		
	
	END


