;*****************************************************************************************
; Program :	Batterry checker
; Description :	Using analog comparator for checking battery 
; Filename :	hlab2101.asm
;*****************************************************************************************
	LIST	P=16F628,W=-302
PORTA	EQU	0x05 			; Bank 0
CMCON	EQU	0x1F
DURATION	EQU	0x70 
COUNT	EQU	0x71
TRISA	EQU	0x85 			; Bank 1
VRCON	EQU	0x9F
C1OUT	EQU	6    			; Bit

	__CONFIG	0x3F61
	ORG	0x0000

	BSF	PORTA,4		; Clear RA4 (OD)

	BANKSEL	TRISA	
	BCF	PORTA,4 		; RA4 as output
	MOVLW	B'10001000' 	; Vref = 2.5 V
	MOVWF	VRCON	 
	
	BANKSEL	CMCON
	MOVLW	B'00000010' 	; Use C1OUT,
	MOVWF	CMCON			; Mode 2	
CHECK	MOVLW	.1
	CALL	DELAY			; Delay ~ 776 uS
	BTFSC	CMCON,C1OUT 	; Lowbatt?
	CALL	ALARM			; Yes
	GOTO	CHECK			; No,then check again
ALARM	MOVLW	.70			; Duration
	MOVWF	DURATION
LOOP	BSF	PORTA,4
	MOVLW	.1			; Frequency
	CALL	DELAY
	BCF	PORTA,4
	MOVLW	.1			; Frequency
	CALL	DELAY
	DECFSZ	DURATION,1	
	GOTO	LOOP
	MOVLW	.0
	CALL	DELAY			; Stop
	CALL	DELAY			; Stop
	CALL	DELAY			; Stop
	CALL	DELAY			; Stop	
	RETURN
DELAY	CLRF	COUNT
	MOVWF	COUNT+1
	DECFSZ	COUNT,1
	GOTO	$-1
	DECFSZ	COUNT+1,1
	GOTO	$-3
	RETURN

	END

