;*****************************************************************************************
; Program :	Reference voltage operation -2
; Description :	Using reference voltage module with external circuit
; Filename :	hlab2301.asm
;*****************************************************************************************
	LIST	P=16F628,W=-302
TRISA	EQU	0x85
TRISB	EQU	0x86
PORTB	EQU	0x06
PORTA	EQU	0x05
VRCON	EQU	0x9F
CMCON	EQU	0x1F

	__CONFIG	0x3F61
	ORG	0x000
	MOVLW	0x02
	MOVWF	CMCON		; Multiplexed input
INIT_PORT	
	BANKSEL	TRISA
	BSF	TRISA,2	; Ensure RA2 as input
	CLRF	TRISB		; Port B as output
	BANKSEL	PORTB
	CLRF	PORTB
	BANKSEL	VRCON	
HI_RANGE
	MOVLW	B'11001111'
	MOVWF	VRCON
STEPUP	INCF	VRCON,1
	MOVFW	VRCON
	BANKSEL	PORTB
	MOVWF	PORTB
	BANKSEL	VRCON
	CALL	DELAY
	MOVLW	B'11001111'
	SUBWF	VRCON,0	
	BNZ	STEPUP
STEPDOWN	DECF	VRCON,1
	MOVFW	VRCON
	BANKSEL	PORTB
	MOVWF	PORTB
	BANKSEL	VRCON
	CALL	DELAY
	MOVLW	B'11000000'
	SUBWF	VRCON,0
	BNZ	STEPDOWN
	GOTO	STEPUP

DELAY   	CLRF	0x70
	CLRF	0x71
	MOVLW	.2	; Change delay here
	MOVWF	0x72
	DECFSZ	0x70,1
	GOTO	$-1
	DECFSZ	0x71,1
	GOTO	$-3
	DECFSZ	0x72,1
	GOTO	$-5
	RETURN
	END
