;*************************************************************************
;Program :		Compare operation
;Description :	Demonstrate comparator of CCP1 module operation
;Processor :	PIC16F628-04 MHz 
;filename :		hlab2601.asm
;*************************************************************************
	LIST	P=16F628,W=-302

PORTB	EQU	0x06
PIR1	EQU	0x0C
TMR1L	EQU	0x0E
TMR1H	EQU	0x0F
T1CON	EQU	0x10
CCPR1L	EQU	0x15
CCPR1H	EQU	0x16
CCP1CON	EQU	0x17
TRISB	EQU	0x86
TMR1ON	EQU	0
CCP1IF	EQU	2

     	CBLOCK	0x70
      	COUNT0,COUNT1,COUNT2
      	 ENDC
	__CONFIG	0x3F61
	ORG	0x0000

	BANKSEL	TRISB		; Initial port
	BCF	TRISB,3		; RB3 as output
	BANKSEL	PORTB		; Bank select

SELECT_HERE	GOTO	PROGRAM4

PROGRAM1	MOVLW	B'00001001' 	; Clear on match mode
	MOVWF	CCP1CON	    ; RB3 = 1 after this instruction
	CALL	DELAY1SEC
	MOVLW	B'00001000' 	; Set on match mode
	MOVWF	CCP1CON	    ; RB3 = 0 after this instruction
	CALL	DELAY1SEC
	GOTO	PROGRAM1

PROGRAM2	BSF	PORTB,3	    ; RB3 = 1
	CALL	DELAY1SEC
	MOVLW	B'00001000' 	; Set on match mode
	MOVWF	CCP1CON	    ; RB3 = 0 after this instruction
	CALL	DELAY1SEC	 
STILL_LOW	BSF	PORTB,3	    ; RB3 still low
	GOTO	$	
	
PROGRAM3	BCF	PORTB,3	    ; RB3 = 0
	CALL	DELAY1SEC
	MOVLW	B'00001001' ; Clear on match mode
	MOVWF	CCP1CON	    ; RB3 = 1 after this instruction
	CALL	DELAY1SEC
STILL_HIGH	BCF	PORTB,3	    ; RB3 still high
	GOTO	$	
	
PROGRAM4	BSF	PORTB,3	    ; RB3 = 1
	CALL	DELAY1SEC
	MOVLW	B'00001000' ; Set on match mode
	MOVWF	CCP1CON	    ; RB3 = 0 after this instruction
	CALL	DELAY1SEC	 
	BSF	PORTB,3	    ; RB3 still low
	CLRF	CCP1CON	    ; Turn-off CCP1 module,
	CALL	DELAY1SEC   ; RB3 = 1 after turn-off
	GOTO	PROGRAM4		

DELAY1SEC	CLRF	COUNT0
	CLRF	COUNT1
	MOVLW	.5
	MOVWF	COUNT2
LOOP	DECFSZ	COUNT0,1
	GOTO	LOOP
	DECFSZ	COUNT1,1
	GOTO	LOOP
	DECFSZ	COUNT2,1
	GOTO	LOOP
	RETURN

	END
