;*************************************************************************
;Program :	500ms single pulse 
;Description :	Using compare module for generating single pulse signal
;Processor :	PIC16F628-04 MHz 
;filename :	hlab2602.asm
;*************************************************************************
	LIST	P=16F628,W=-302

PORTB	EQU	0x06
PIR1	EQU	0x0C
TMR1L	EQU	0x0E
TMR1H	EQU	0x0F
T1CON	EQU	0x10
CCPR1L	EQU	0x15
CCPR1H	EQU	0x16
CCP1CON	EQU	0x17

TRISB	EQU	0x86

TMR1ON	EQU	0
CCP1IF	EQU	2

	__CONFIG	0x3F61
	ORG	0x0000

	BANKSEL	TRISB				; Initial port
	MOVLW	B'11110111' 		; RB3 as output,RB0 as input 
	MOVWF	TRISB
	BANKSEL	PORTB				; Bank select
	BCF	PORTB,3
	MOVLW	0xF4				; 0.5 second
	MOVWF	CCPR1H
	MOVLW	0x23
	MOVWF	CCPR1L
	MOVLW	B'00110000'		; Prescaler = 1:8,internal clock
	MOVWF	T1CON	
LOOP	CLRF	TMR1H
	CLRF	TMR1L
READ_SW	BTFSC	PORTB,0			; Is S1 pressed ?
	GOTO	READ_SW			; No
	MOVLW	B'00001001'		; Clear on match mode
	MOVWF	CCP1CON
	BSF	T1CON,TMR1ON		; Start Timer1
WAIT1	BTFSS	PIR1,CCP1IF		; Wati for mathcing
	GOTO	WAIT1
	BCF	T1CON,TMR1ON		; Stop Timer1
	BCF	PIR1,CCP1IF 		; Clear flag
	CLRF	CCP1CON
WAIT2	BTFSS	PORTB,0			; S1 release?
	GOTO	WAIT2				; Not yet
	GOTO	LOOP

	END
