;*************************************************************
; Program : Serial data transmission
; Description :Using USART module for RS-232 transmitting data 
; Filename : hlab2801.asm
;*************************************************************
	LIST	P=16F628,W=-302
PIR1	EQU	0x0C					; Bank 0
RCSTA	EQU	0x18
TXREG	EQU	0x19
TRISB	EQU	0x86					; Bank 1
TXSTA	EQU	0x98
SPBRG	EQU	0x99
TXIF	EQU	4					; Bit
TXEN	EQU	5
SYNC	EQU	4
BRGH	EQU	2
SPEN	EQU	7
CREN	EQU	4

	__CONFIG	0x3F61				; XT 4 MHz, WDT off

	ORG	0x0000
	
	BANKSEL	TRISB				; Bank 1
	BSF	TRISB,2				; RB2 as input
	
	MOVLW	.25
	MOVWF	SPBRG				; Baudrate = 9600 bps
	BSF	TXSTA,BRGH			; Hi-speed
	BSF	TXSTA,TXEN			; TX enable

	BANKSEL	RCSTA				; Bank 0
	BSF	RCSTA,SPEN  			; Serial port enable
	
	MOVLW	'H'					; Load ASCII data
	CALL	SEND_DATA			; Send data
	MOVLW	'e'
	CALL	SEND_DATA
	MOVLW	'l'
	CALL	SEND_DATA
	MOVLW	'l'
	CALL	SEND_DATA
	MOVLW	'o'
	CALL	SEND_DATA	

	GOTO	$					; Endless loop
 
SEND_DATA	BTFSS	PIR1,TXIF			; Skip if TXREG empty
	GOTO	$-1					; Not empty then wait 
	MOVWF	TXREG				; Send data to RS-232	
	RETURN

	END
