;**************************************************************************
;Program :	Power-on reset status
;Description :	Observing POR flag in PCON register for power-on reset operation 
;filename :	hlab2901.asm
;**************************************************************************
	LIST	P=16F628,w=-302

PORTB	EQU	0x06				; Bank 0
BUFFER	EQU	0x70				; Every bank
TRISB	EQU	0x86				; Bank 1
PCON	EQU	0x8E 

POR	EQU	1

	__CONFIG	0x3F29
	ORG	0x0000
CHECK		
	BANKSEL	TRISB				; Bank select
	BCF	TRISB,1			; RB1 as output
	MOVFW	PCON
	MOVWF	BUFFER
	BANKSEL	PORTB				; Bank select
	MOVFW	BUFFER
	MOVWF	PORTB

READ_SW	BTFSC	PORTB,0			; RB0 as input after power-on reset
	GOTO	CHECK
	BANKSEL	PCON				; Bank select	
	BSF	PCON,POR
	GOTO	CHECK
	
	END
