;***************************************************************************
;Program :		Wake-up
;Description :	Demonstrate waking up from sleep mode 
;		by interrupt on port B changing
;		(do not real interrupt occur-use RBIF flag setting instead)
;filename :		hlab3002.asm
;***************************************************************************
	LIST	P=16F628,W=-302

PORTA	EQU	0x05		; Bank 0
PORTB	EQU	0x06	 
INTCON	EQU	0x0B	
CMCON	EQU	0x1F
OPTION_REG	EQU	0x81		; Bank 1
TRISB	EQU	0x86
TRISA	EQU	0x85 
BUFFER	EQU	0x20		; Bank 0
RBIE	EQU	3
RBIF	EQU	0

	__CONFIG	0x3F50
	ORG	0x000
	
	MOVLW	.7			; PORTA as digital I/O
	MOVWF	CMCON
	BANKSEL	TRISA
	BCF	TRISA,0		; RA4 as output for RBIF Bit
	MOVLW	B'11110000'	; RB7-RB4 =as input
	MOVWF	TRISB		; RB3-RB0 as output
	BANKSEL	PORTB
	CLRF	PORTB
	BCF	PORTA,0
	BCF	INTCON,RBIF	; Clear after power-on reset
	BSF	INTCON,RBIE	; Enable interrupt
DEEP_SLEEP	SLEEP				; Enter power down mode
	NOP				; Should be use after SLEEP instruction
	BCF	INTCON,RBIE	; Disable interrupt	
	BSF	PORTA,0	
	COMF	PORTB,0
	MOVWF	BUFFER
	SWAPF	BUFFER,0
	MOVWF	PORTB		; Display
WAIT4RELEASE	MOVFW	INTCON
	MOVWF	PORTA
	MOVLW	B'11110000' 	; Is switch released ?
	ANDWF	PORTB,0
	SUBLW	B'11110000'
	BNZ	WAIT4RELEASE	; Not yet
	CLRF	PORTB		; Yes
	BCF	PORTA,0
	BCF	INTCON,RBIF
	BSF	INTCON,RBIE	; Re-enable interrupt
	GOTO	DEEP_SLEEP
	
	END
