;********************************************************************
; Program : 	Output expansion with latch
; Description : 	Demonstrate using 74HC595 for output port expansion
; Filename : 	hlab3102.asm
;********************************************************************
   	LIST 	P=16F628,W=-302
STATUS	EQU	0x03
PORTA	EQU	0x05
CMCON	EQU	0x1F
TRISA	EQU	0x85
SEND	EQU	0x70
COUNT	EQU	0x71
COUNT1	EQU	0x72
COUNT2	EQU	0x73
RP0	EQU	5				; Status bit define
C	EQU	0
W	EQU	0
F	EQU	1

	__CONFIG	0x3F61
 	ORG 	0x000
	MOVLW	.7
	MOVWF	CMCON			; RA3-RA0 as digital I/O
START	BSF	STATUS,RP0		; Bank 1
	CLRF	TRISA			; PORTA as output
	BCF	STATUS,RP0		; Bank 0

	MOVLW	0x04
	MOVWF	PORTA
	BCF	PORTA,2		; Clear
	BSF	PORTA,2
	MOVLW	0xAA			; Data to send 1st
	CALL	SEND_DATA

;	BSF	PORTA,3		
;	BCF	PORTA,3
;	CALL	DELAY		
;	CALL	DELAY		
;	CALL	DELAY
	MOVLW	0x0F			; Send 2nd data
	CALL	SEND_DATA
	BSF	PORTA,3	; Latch
	BCF	PORTA,3	
	GOTO	$

; SEND DATA TO 74HC595 ;
SEND_DATA	MOVWF	SEND	; Load data
	MOVLW	0x08	; Load counter	
	MOVWF	COUNT	
CHK_BIT	BCF	PORTA,0		
	BTFSC	SEND,7	; Test bit to send
	BSF	PORTA,0
CLOCK	BSF	PORTA,1	; Send clock
	BCF	PORTA,1
ROTATE	RLF	SEND,F	; Shift data
	DECFSZ	COUNT,F	; Test COUNT
	GOTO	CHK_BIT
	RETURN

; DELAY SUB ;

DELAY	MOVLW	0xFF
	MOVWF	COUNT1
DEC2	MOVLW	0xFF
	MOVWF	COUNT2
DEC1	DECFSZ	COUNT2,F
	GOTO	DEC1
	DECFSZ	COUNT1,F
	GOTO	DEC2
	RETURN
	END

