;********************************************************************
; Program : Input expansion
; Description : Demonstrate using 74HC165 for input port expansion
; Filename : hlab3103.asm
;************************************************************
   	LIST 	P=16F628,w=-302
	__CONFIG	0x3F61

STATUS	EQU	0x03
PORTA	EQU	0x05
PORTB	EQU	0x06
CMCON	EQU	0x1F
TRISA	EQU	0x85
RCV	EQU	0x70
COUNT	EQU	0x71
TEMP	EQU	0x72
RP0	EQU	5			; Status bit define
C	EQU	0
W	EQU	0
F	EQU	1

 	ORG 	0x0000

	MOVLW	.7
	MOVWF	CMCON			; RA3-RA0 as digital I/O
START	BSF	STATUS,RP0	; Bank 1
	CLRF	PORTB			; PORTB as output
	MOVLW	0x01
	MOVWF	PORTA			; RA0 = INPUT
	BCF	STATUS,RP0	; Bank 0

; MAIN ;

	MOVLW	0x04			; Initial
	MOVWF	PORTA	
LOOP	CALL	SER_IN
	MOVF	RCV,W
	MOVWF	PORTB
	GOTO	LOOP

; READ INPUT FROM 74HC165  ;

SER_IN	CLRF	RCV			; Clear received register
	MOVLW	0x08			; Load counter	
	MOVWF	COUNT	
	BCF	PORTA,2		; Load pulse
	BSF	PORTA,2
GETBIT	MOVF	PORTA,W		; Read data
	MOVWF	TEMP			; STORE
	RRF	TEMP,F		; Rotate RA0 to Carry flag
	RLF	RCV,F			; Rotate Carry flag to RCV register
	DECFSZ	COUNT,F		; Test counter
	GOTO	SHIFT
	RETURN

SHIFT	BSF	PORTA,1		; Clock pulse
	BCF	PORTA,1
	GOTO	GETBIT		; Read again

	END		
