;***************************************************
; Program : 	93C46 Writing 
; Description : 	Demonstrate writing data to 93C46
; Filename : 	hlab3201.asm
;***************************************************

	LIST 	P=16F628,w=-302
; BYTE DEFINE ;

STATUS	EQU	0x03
PORTA	EQU	0x05
PORTB	EQU	0x06
TRISA	EQU	0x85
TRISB	EQU	0x86
CMCON	EQU	0x1F

     	CBLOCK    0x70
      	ADDRESS,TEMP,COUNT,H_BYTE,L_BYTE,DATA_L,DATA_H
     	ENDC
        
; BIT DEFINE ;

RP0	EQU	5			; Status bit define
W	EQU	0
F	EQU	1

	__CONFIG	0x3F61
 	ORG 	0x0000

; SET PORT ;

	MOVLW	.7
	MOVWF	CMCON			; RA3-RA0 = digital I/O
START	BSF	STATUS,RP0	; Bank 1
	MOVLW	B'00000001'	; RA0 as input
	MOVWF	TRISA
	CLRF	TRISB			; PORTB as output
	BCF	STATUS,RP0	; Bank 0

; INITIAL EEPROM ;	

	BCF	PORTA,1
	BCF	PORTA,2 
	BCF	PORTA,3
	CLRF	PORTB	; LED off


;MAIN ;
	CALL	ERASE			; Erase EEPROM 

	CLRF	ADDRESS	
	MOVLW	0x3F	
	MOVWF	H_BYTE
	MOVLW	0x06
	MOVWF	L_BYTE
	CALL	WRITE
	
	INCF	ADDRESS,F	
	MOVLW	0x5B	
	MOVWF	H_BYTE
	MOVLW	0x4F
	MOVWF	L_BYTE
	CALL	WRITE
	
	INCF	ADDRESS,F	
	MOVLW	0x66	
	MOVWF	H_BYTE
	MOVLW	0x6D 
	MOVWF	L_BYTE
	CALL	WRITE
	
	INCF	ADDRESS,F	
	MOVLW	0x7D	
	MOVWF	H_BYTE
	MOVLW	0x07
	MOVWF	L_BYTE
	CALL	WRITE
	
	INCF	ADDRESS,F	
	MOVLW	0x7F	
	MOVWF	H_BYTE
	MOVLW	0x6F
	MOVWF	L_BYTE
	CALL	WRITE
	
	INCF	ADDRESS,F	
	MOVLW	0x77	
	MOVWF	H_BYTE
	MOVLW	0x7C
	MOVWF	L_BYTE
	CALL	WRITE
	
	INCF	ADDRESS,F	
	MOVLW	0x39	
	MOVWF	H_BYTE
	MOVLW	0x5E
	MOVWF	L_BYTE
	CALL	WRITE
	
	INCF	ADDRESS,F	
	MOVLW	0x79	
	MOVWF	H_BYTE
	MOVLW	0x71
	MOVWF	L_BYTE
	CALL	WRITE

	MOVLW	0x05	
	MOVWF	ADDRESS	
	CALL	READ	
	MOVF	DATA_H,W
	MOVWF	PORTB	

	GOTO	$

	INCLUDE "EE9346_1.ASM"
	
	END
