;***************************************************************
; Program : 	93C46 reading
; Filename : 	hlab3202.asm
;***************************************************************
	LIST 	P=16F628,W=-302
STATUS	EQU	0x03
PORTA	EQU	0x05
PORTB	EQU	0x06
TRISA	EQU	0x85
TRISB	EQU	0x86
CMCON	EQU	0x1F
RP0	EQU	5	 		; Status bit define
W	EQU	0
F	EQU	1

     	CBLOCK    0x70
	ADDRESS,TEMP,COUNT,H_BYTE,L_BYTE,DATA_L,DATA_H,COUNT1,COUNT2
  	ENDC

	__CONFIG	0x3F61
 	ORG 	0x0000
	MOVLW	.7
	MOVWF	CMCON			; RA3-RA0 = digital I/O
START	BSF	STATUS,RP0	; Bank 1
	MOVLW	B'00000001'	; RA0 as input
	MOVWF	TRISA
	CLRF	TRISB			; PORTB as output
	BCF	STATUS,RP0	; Bank 0
 	BCF	PORTA,1
	BCF	PORTA,2
	BCF	PORTA,3
	CLRF	PORTB			; 7 segment off
LOOP	CLRF	ADDRESS		; Start address 0
AGAIN	CALL	READ			; Read data from EEPROM
	MOVF	DATA_H,W		; Read data high
	MOVWF	PORTB			; Show data to LED 7 segment
	CALL	DELAY		
	MOVF	DATA_L,W		; Read data low 
	MOVWF	PORTB
	CALL	DELAY
	INCF	ADDRESS,F	; Next address
	BTFSS	ADDRESS,3	; Address> 7 ?
	GOTO 	AGAIN
	GOTO	LOOP

DELAY 	MOVLW	0xFF
	MOVWF	COUNT1
DELAY2	MOVLW	0xFF	
	MOVWF	COUNT2
DELAY1	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECFSZ	COUNT2,F
	GOTO	DELAY1
	DECFSZ	COUNT1,F
	GOTO	DELAY2	
	RETURN
	INCLUDE 	"EE9346_1.ASM"
	END
