;***************************************************
; Program : 93C46 erasing
; Description : Demonstrate erasing data in 93C46
; Filename : hlab3203.asm
;***************************************************
	LIST 	P=16F628,W=-302
; BYTE DEFINE ;

STATUS	EQU	0x03
PORTA	EQU	0x05
PORTB	EQU	0x06
TRISA	EQU	0x85
TRISB	EQU	0x86
CMCON	EQU	0x1F

     	CBLOCK    0x70
 	ADDRESS,TEMP,COUNT,H_BYTE,L_BYTE, DATA_L,DATA_H,COUNT1,COUNT2
 	ENDC
        
; BIT DEFINE ;

RP0	EQU	5	 		; Status bit define
W	EQU	0
F	EQU	1

	__CONFIG	0x3F61
 	ORG 	0x0000

; SET PORT ;
	
	MOVLW	.7
	MOVWF	CMCON			; RA3-RA0 = digital I/O
START	BSF	STATUS,RP0	; Bank 1
	MOVLW	B'00000001'	; RA0 as input
	MOVWF	TRISA
	CLRF	TRISB	; PORTB as output
	BCF	STATUS,RP0	; Bank 0

; MAIN ;	

	BCF	PORTA,1
	BCF	PORTA,2
	BCF	PORTA,3 
	CLRF	PORTB			; LED 7 segment off
	CLRF	ADDRESS		; Start address 0
LOOP	CALL	ERASE			; Read data from EEPROM
	INCF	ADDRESS,F	; Next address
	BTFSS	ADDRESS,2	; Address > 3 ?
	GOTO 	LOOP
	GOTO	$

	INCLUDE "EE9346_1.ASM"
	
	END
