;******************************************************************
; Program : 	Sinewave generator
; Description : 	Using 8-bit R-2R ladder DAC to generate sine signal
; Filename : 	hlab3403.asm
;****************************************************************** 
	LIST	P=16F628,W=-302
	__CONFIG 0x3F61
PCL	EQU	0x02
STATUS	EQU	0x03
PORTB	EQU	0x06
TRISB	EQU	0x86
VOLTS	EQU	0x70
COUNT	EQU	0x71
RP0	EQU	5
W	EQU	0
F	EQU	1
	
	ORG	0x000
START	BSF	STATUS,RP0 	; Bank 1
	CLRF	TRISB			; PORTB as output	
	BCF	STATUS,RP0	; Bank 0	
	CLRF	PORTB
LOOP	MOVLW	.35			; Cycle count
	MOVWF	COUNT
	CLRF	VOLTS			; Clear table index
STEP	MOVF	VOLTS,W		; Read index
	CALL	TABLE_		; Read data from table
	MOVWF	PORTB			; Send to output
	DECFSZ	COUNT,F		; Cycle = 35 ?
	GOTO	INCR			; No
	GOTO	LOOP
INCR	INCF	VOLTS,F		; Increment index
	GOTO	STEP			; Next index
; SIN GEN  -
TABLE_	ADDWF	PCL,F
	RETLW	0x80
	RETLW	0x95
	RETLW	0xAD
	RETLW	0xC1
	RETLW	0xD3
	RETLW	0xE2
	RETLW	0xEF
	RETLW	0xF8
	RETLW	0xFD
	RETLW	0xFF	
	RETLW	0xFD
	RETLW	0xF8
	RETLW	0xEF
	RETLW	0xE2
	RETLW	0xD3
	RETLW	0xC1
	RETLW	0xAD
	RETLW	0x95
	RETLW	0x80	
	RETLW	0x6A
	RETLW	0x54
	RETLW	0x40
	RETLW	0x2E
	RETLW	0x1E
	RETLW	0x11
	RETLW	0x08
	RETLW	0x02
	RETLW	0x00
	RETLW	0x08
	RETLW	0x11
	RETLW	0x1E
	RETLW	0x2E
	RETLW	0x40
	RETLW	0x54
	RETLW	0x6A

	END
 

