;****************************************************
; Program : Stepper motor controller -1
; Description : Demonstrate controlling stepper motor
; filename : hlab3601.asm
;****************************************************
	LIST 	P=16F628,W=-302
	__CONFIG 0x3F61

STATUS	EQU	0x03
PORTB	EQU	0x06
TRISB	EQU	0x86
MCOUNT	EQU	0x70
NCOUNT	EQU	0x71
C	EQU	0
RP0	EQU	5
W	EQU	0
F	EQU	1
	
	ORG	0x000

START	BSF	STATUS,RP0		; Bank 1
	CLRF	TRISB			; PORTB as output
	BCF	STATUS,RP0		; Bank 0
	CLRF	PORTB

AGAIN	MOVLW	0x01			; Start bit 1
	MOVWF	PORTB
LOOP	CALL	DELAY		
	BTFSC	PORTB,3			; RB3 set?
	GOTO	AGAIN
	BCF	STATUS,C		; No, clear Carry flag
	RLF	PORTB,F			; Rotate bit
	GOTO	LOOP

; DELAY SUBROUTINE 

DELAY	MOVLW	0x20
	MOVWF 	MCOUNT
M_DEC	MOVLW	0xFF
	MOVWF	NCOUNT
N_DEC	DECFSZ	NCOUNT,F
	GOTO	N_DEC
	DECFSZ	MCOUNT,F
	GOTO	M_DEC
	RETURN

	END
