;*****************************************************************
; Program :	Stepper motor controller -2
; filename : 	hlab3602.asm
;*****************************************************************
	LIST 	P=16F628,W=-302
	__CONFIG 0x3F61
STATUS	EQU	0x03
PORTA	EQU	0x05
PORTB	EQU	0x06
CMCON	EQU	0x1F
TRISA	EQU	0x85
TRISB	EQU	0x86
MCOUNT	EQU	0x70
NCOUNT	EQU	0x71
C	EQU	0
RP0	EQU	5
W	EQU	0
F	EQU	1
	
	ORG	0x000
	MOVLW	.7
	MOVWF	CMCON			; RA3-RA0 as digital I/O
START	BSF	STATUS,RP0	; Bank 1
	CLRF	TRISB			; PORTB as output
	MOVLW	0x01			; RA0 as input
	MOVWF	TRISA
	BCF	STATUS,RP0	; Bank 0
	CLRF	PORTB
C_LEFT	CALL	LEFT			; Turn left first
	BTFSC	PORTA,0		; Check key pressed
	GOTO	C_LEFT		; Not pressed 
WAIT1	BTFSS	PORTA,0		; Wait until key up
	GOTO	WAIT1
C_RIGHT	CALL	RIGHT			; Turn right
	BTFSC	PORTA,0		; Check ket pressed
	GOTO	C_RIGHT		; Not pressed
WAIT2	BTFSS	PORTA,0		; Wait until key up
	GOTO	WAIT2
	GOTO	C_LEFT
	
DELAY30	MOVLW	0x10			; Delay routine	
	MOVWF 	MCOUNT
M_DEC	MOVLW	0xFF
	MOVWF	NCOUNT
N_DEC	DECFSZ	NCOUNT,F
	GOTO	N_DEC
	DECFSZ	MCOUNT,F
	GOTO	M_DEC
	RETURN
        
LEFT	MOVLW	B'11111100'	; Turn left routine
	MOVWF	PORTB
	CALL	DELAY30
	MOVLW	B'11110110'
	MOVWF	PORTB
	CALL	DELAY30
	MOVLW	B'11110011'
	MOVWF	PORTB
	CALL	DELAY30
	MOVLW	B'11111001'
	MOVWF	PORTB
	CALL	DELAY30
	RETURN
RIGHT	MOVLW	B'11111001'	; Turn right routine
	MOVWF	PORTB
	CALL	DELAY30
	MOVLW	B'11110011'
	MOVWF	PORTB
	CALL	DELAY30
	MOVLW	B'11110110'
	MOVWF	PORTB
	CALL	DELAY30
	MOVLW	B'11111100'
	MOVWF	PORTB
	CALL	DELAY30
	RETURN

	END
