;**************************************************************
; Program :	Basic indirect addressing mode
: Description :	Demonstrate accessing RAM address 0x20 and 0x120 with indirect addressing mode by defining IRP bit in STATUS register
; Filename :	lab0101.asm
;**************************************************************

	LIST	P=16F628

XXXX	EQU	0X20	; RAM ADDRESS
YYYY	EQU	0X120	; RAM ADDRESS

INDF	EQU	0X00
STATUS	EQU	0X03
FSR	EQU	0X04
IRP	EQU	7

START	ORG	0X000

; WRITE 0XAA TO ADDR. 0X20	
	BCF	STATUS,IRP	; 1ST: SELECT BANK 0 OR 1	  
	MOVLW	0X20	; 2ND: PUT RAM ADDRESS 
	MOVWF	FSR  	;      TO FSR
	MOVLW	0XAA	; 3RD: WRITE 0XAA TO XXXX
	MOVWF	INDF	
; WRITE 0XBB TO ADDR. 0X120		
	BSF	STATUS,IRP	; BANK 2 OR 3
	MOVLW	0X20	; ADDR. TO FSR
	MOVWF	FSR	
	MOVLW	0XBB	; WRITE 0XBB TO YYYY
	MOVWF	INDF	

	GOTO	START	
	
	END