;*****************************************************************************
; Program :	Status register testing
; Description :	Demonstrate operation of flag in STATUS register
; Filename :	lab0201.asm
;*****************************************************************************
	LIST 	P=16F628

TEST1  	EQU	0x21 		;  Define registers for operating
TEST2  	EQU 	0x22
STATUS	EQU	0x03
W	EQU	0
F	EQU	1

	ORG 	0x00

LOOP	MOVLW  	0x80            ; Set "TEST1" to 0x080
  	MOVWF  	TEST1
  	MOVLW  	0x08		; Set "TEST2" to 0x08
  	MOVWF  	TEST2		

; Clear the Status Flags before doing any operations

	MOVLW   b'11111000'  	; Clear status flags	
  	ANDWF   STATUS,F

	MOVF  	TEST1,W         ; Zero flag not changed
	XORWF 	TEST1,W         ; Zero flag set after execute

  	MOVF  	TEST1,W         	
  	ADDWF 	TEST1,W		; Set Carry and Zero 

	MOVLW   b'11111000'	; Clear status flags	
  	ANDWF   STATUS,F

  	MOVF  	TEST2,W         ; Show the Digit Carry flag 
  	ADDWF 	TEST2,W         	

  	MOVF  	TEST1,W    	; Set all status bits
  	SUBWF 	TEST1,W
  	MOVWF 	TEST1
	
	MOVLW   b'11111000' 	; Clear status flags	
  	ANDWF   STATUS,F
  
  	MOVF  	TEST1,W        	; Zero flag set

	GOTO  	LOOP           	; Test again

 	END
