;****************************************************************
; Program :	Shift bit
; Description :	Demonstrate shifting bit in register file
; Filename : 	lab0601.asm
;***************************************************************

	LIST 	P=16F628
STATUS	EQU	0x03
PORTB	EQU	0x06
SHIFT	EQU	0x0c
W	EQU	0
F	EQU	1
RP0	EQU	5
C	EQU	0
 	
	ORG 	0x00
	BSF	STATUS,RP0	; Select bank 1
	MOVLW	0x00		; Port B as output
	MOVWF	PORTB		
	BCF	STATUS,RP0	; Select bank 0
	BCF	STATUS,C	; Clear Carry flag
	CLRF	PORTB		; Clear output port

START	MOVLW	b'00000001'	; Start with LSB 
	MOVWF	SHIFT		; Store in SHIFT

LEFT	MOVF	SHIFT,W
	MOVWF	PORTB		; Display
	RLF	SHIFT,F		; Rotate left
	BTFSS	STATUS,C	; Carry set ?
	GOTO 	LEFT		; Not set, rotate left
RIGHT	MOVF	SHIFT,W		; Carry set,rotate right
	MOVWF	PORTB
	RRF	SHIFT,F		; Rotate right
	BTFSS	STATUS,C	; Carry Set ?
	GOTO	RIGHT		; Not set,rotate right
	GOTO	LEFT		; Carry set, rotate left

	END
