;**********************************************************************************************************
; Program :	16-bit addition
; Description :	Demonstrate operation of 16-bit,
;		 the result low-byte is stored in LSB2 and high-byte is stored in MSB2 register
; Filename :	lab0807.asm
;**********************************************************************************************************
	LIST	P=16F628
	
STATUS	EQU	0x03
PORTB	EQU	0x06
LSB1	EQU	0x20
LSB2	EQU	0x22
MSB1	EQU	0x21
MSB2	EQU	0x23
W	EQU	0
F	EQU	1
RP0	EQU	5
C	EQU	0

	ORG 	0x00

INIT	BSF	STATUS,RP0	; Select bank 1
	MOVLW	0x00		; Port B as Output	
	MOVWF	PORTB		
	BCF	STATUS,RP0	; Select bank 0
	CLRF	PORTB		; Clear output port
START	MOVLW	0xFF		; Test number 1	
	MOVWF	LSB1
	MOVLW	0x0F		; Test number 2
	MOVWF	MSB1
	MOVLW	0x01		; Test number 3
	MOVWF	LSB2
	MOVLW	0x00		; Test number 4
	MOVWF	MSB2		
	CALL	DBPLUS		; To double addition

RESULT	MOVF	LSB2,W		; Get LSB2
	MOVWF	PORTB		; Display LSB2 via Port B
	MOVF	MSB2,W		; Get MSB2
	MOVWF	PORTB		; Display MSB2 via Port B

CYCLE	GOTO	CYCLE		; Done

DBPLUS	MOVF	LSB1,W		; Fetch LSB1
	ADDWF	LSB2,F		; Add low bytes, result in LSB2
	BTFSC	STATUS,C	; Carry flag set ?
	INCF	MSB2,F		; Carry flag set, Increase MSB2
	MOVF	MSB1,W		; Fetch	MSB1
	ADDWF	MSB2,F		; Add high bytes , result in LSB2
	RETURN
	END
