;*************************************************************
; Program : 16-bit multiplier
; Filename : lab0808.asm
;*************************************************************

	LIST	P=16F628

R0H	EQU	0x70	; ALU
R0L	EQU	0x71
R1H	EQU	0x72
R1L	EQU	0x73

MULCND_HIGH	EQU	0x74	; Variable
MULCND_LOW	EQU	0x75
MULPLR_HIGH	EQU	0x76
MULPLR_LOW	EQU	0x77	

PRODUCT3	EQU	0x74	; Result 32 bit =
PRODUCT2	EQU	0x75	; PRODUCT3:PRODUCT2:PRODUCT1:PRODUCT0
PRODUCT1	EQU	0x76
PRODUCT0	EQU	0x77

COUNT16	EQU	0x78

;====================================================================
;  INPUT 16 BIT  =>  MULCND_HIGH:MULCND_LOW  for multiplicand
;  	      MULPLR_HIGH:MULPLR_LOW  for multiplier
;  OUTPUT 32 BIT =>  PRODUCT3:PRODUCT2:PRODUCT1:PRODUCT0 for result
;====================================================================
	ORG	0x0000
;***********************  MULTIPLICAND INPUT ************************
	MOVLW	0x12	
	MOVWF	MULCND_HIGH
	MOVLW	0x34		; Multiplicand = 0x1234
	MOVWF	MULCND_LOW

;***********************  MULTIPLIER INPUT  *************************
	MOVLW	0x56	
	MOVWF	MULPLR_HIGH
	MOVLW	0x78		; Multiplier = 0x5678
	MOVWF	MULPLR_LOW
;********************************************************************
TEST_PROGRAM	
	CALL	MUL1616
	GOTO	$

MUL1616	CLRF	R0H
	CLRF	R0L
	MOVLW	.16			; For 16 times loop
	MOVWF	COUNT16	

LOOP16	RRF	MULPLR_HIGH,1  
	RRF	MULPLR_LOW,1	
	SKPC				; Check LSB bit of multiplier
	GOTO	RESULT32		
	MOVFW	MULCND_LOW		; Add 16 bit with Carry
	ADDWF	R0L,1
	MOVFW	MULCND_HIGH
	SKPNC
	INCFSZ	MULCND_HIGH,0
	ADDWF	R0H,1		

RESULT32	
	RRF	R0H,1			; Rotate right 1 bit for next addition
	RRF	R0L,1
	RRF	R1H,1
	RRF	R1L,1	
	DECFSZ	COUNT16,1		; Do finish?
	GOTO	LOOP16			; No,do again
	MOVFW	R0H			; Yes,get answer
	MOVWF	PRODUCT3		; Result
	MOVFW	R0L
	MOVWF	PRODUCT2		; Result
	MOVFW	R1H
	MOVWF	PRODUCT1		; Result
	MOVFW	R1L
	MOVWF	PRODUCT0		; Result
	RETURN

	END