;*******************************************************
; Program : 16-bit divider
; Filename : lab0812.asm
;*******************************************************


	LIST	P=16F628

QUOTIENT_LOW	EQU	0X70
QUOTIENT_HIGH	EQU	0X71
R1LOW	EQU	0X72
R1HIGH	EQU	0X73
REMAINDER_LOW	EQU	0X74
REMAINDER_HIGH	EQU	0X75
COUNTER	EQU	0X76


	ORG	0X000

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; INPUT  => 	DIVIDEND / DIVISOR (X / Y)
; OUTPUT =>    QUOTIENT_HIGH:QUOTIENT_LOW.REMAINDER_HIGH:REMAINDER_LOW
; QUOTIENT  	= X / Y
; REMAINDER 	= X MOD Y		
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

     CONSTANT	X   =  0X1000		; CHANGE DIVIDEND HERE
     CONSTANT	Y   =  0X100		; CHANGE DIVISOR  HERE

TEST_PROGRAM	MOVLW	HIGH X	; HIGH BYTE OF DIVIDEND X
	MOVWF	QUOTIENT_HIGH
	MOVLW	LOW  X	; LOW  BYTE OF DIVIDEND X
	MOVWF	QUOTIENT_LOW

	MOVLW	HIGH Y	; HIGH BYTE OF DIVISOR Y
	MOVWF	R1HIGH
	MOVLW	LOW  Y	; LOW  BYTE OF DIVISOR Y
	MOVWF	R1LOW
	
	CALL	DIV16
	GOTO	$         
;**********************************************************************	
DIV16	MOVLW	.16
	MOVWF	COUNTER
	CLRF	REMAINDER_HIGH
	CLRF	REMAINDER_LOW

DIVIDE_LOOP	RLF	QUOTIENT_HIGH,0
	RLF	REMAINDER_LOW,1
	RLF	REMAINDER_HIGH,1
	MOVFW	R1LOW
	SUBWF	REMAINDER_LOW,1
	MOVFW	R1HIGH
	SKPC
	INCFSZ	R1HIGH,0
	SUBWF	REMAINDER_HIGH,1
	
	SKPNC
	GOTO	RESULT
	MOVFW	R1LOW
	ADDWF	REMAINDER_LOW,1
	MOVFW	R1HIGH
	SKPNC
	INCFSZ	R1HIGH,0
	ADDWF	REMAINDER_HIGH,1
	CLRC	

RESULT	RLF	QUOTIENT_LOW,1
	RLF	QUOTIENT_HIGH,1
	DECFSZ	COUNTER,1
	GOTO	DIVIDE_LOOP
	RETURN

	END